/* Generated by wayland-scanner 1.18.0 */

#ifndef ZWP_WWW_SERVER_PROTOCOL_H
#define ZWP_WWW_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_zwp_www The zwp_www protocol
 * @section page_ifaces_zwp_www Interfaces
 * - @subpage page_iface_www - 
 * - @subpage page_iface_www_surface - 
 */
struct wl_surface;
struct www;
struct www_surface;

/**
 * @page page_iface_www www
 * @section page_iface_www_api API
 * See @ref iface_www.
 */
/**
 * @defgroup iface_www The www interface
 */
extern const struct wl_interface www_interface;
/**
 * @page page_iface_www_surface www_surface
 * @section page_iface_www_surface_api API
 * See @ref iface_www_surface.
 */
/**
 * @defgroup iface_www_surface The www_surface interface
 */
extern const struct wl_interface www_surface_interface;

/**
 * @ingroup iface_www
 * @struct www_interface
 */
struct www_interface {
	/**
	 * Create an object for WWW notifications
	 *
	 * 
	 */
	void (*create)(struct wl_client *client,
		       struct wl_resource *resource,
		       uint32_t id,
		       struct wl_resource *surface);
};


/**
 * @ingroup iface_www
 */
#define WWW_CREATE_SINCE_VERSION 1

/**
 * @ingroup iface_www_surface
 * @struct www_surface_interface
 */
struct www_surface_interface {
	/**
	 * Destroy a www_surface
	 *
	 * 
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
};

#define WWW_SURFACE_STATUS 0
#define WWW_SURFACE_START_DRAG 1
#define WWW_SURFACE_END_DRAG 2

/**
 * @ingroup iface_www_surface
 */
#define WWW_SURFACE_STATUS_SINCE_VERSION 1
/**
 * @ingroup iface_www_surface
 */
#define WWW_SURFACE_START_DRAG_SINCE_VERSION 1
/**
 * @ingroup iface_www_surface
 */
#define WWW_SURFACE_END_DRAG_SINCE_VERSION 1

/**
 * @ingroup iface_www_surface
 */
#define WWW_SURFACE_DESTROY_SINCE_VERSION 1

/**
 * @ingroup iface_www_surface
 * Sends an status event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
www_surface_send_status(struct wl_resource *resource_, int32_t x_rel, int32_t y_rel, uint32_t timestamp)
{
	wl_resource_post_event(resource_, WWW_SURFACE_STATUS, x_rel, y_rel, timestamp);
}

/**
 * @ingroup iface_www_surface
 * Sends an start_drag event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
www_surface_send_start_drag(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, WWW_SURFACE_START_DRAG);
}

/**
 * @ingroup iface_www_surface
 * Sends an end_drag event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
www_surface_send_end_drag(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, WWW_SURFACE_END_DRAG);
}

#ifdef  __cplusplus
}
#endif

#endif
